function [newX, newY] = compose_fsl_mat(refR, ratio, X, Y)

newX = []; newY = [];

for label = sort(unique(Y)')
  idx = find(Y==label);
  if ismember(label , refR)
    % fprintf('label %d in ref member \n', label)
    newX = [newX; X(idx,:)];
    newY = [newY; Y(idx,:)];
  else
    % fprintf('label %d not in ref member \n', label)
    if ratio == 0
      continue
    end
    xx = X(idx,:);
    yy = Y(idx,:);
    if ratio < 1
      [~,test] = crossvalind('HoldOut',yy, ratio);
    else
      if ratio < size(yy,1)
        [~,test] = crossvalind('HoldOut',yy, ratio/size(yy,1));
      elseif ratio == size(yy,1)
        test = 1:size(yy,1);
      else
        assert(false);
      end
    end
    xx = xx(test,:);yy = yy(test,:);
    newX = [newX; xx];
    newY = [newY; yy];
  end
end