function [y] = gen_symbols_amc2(MOD_NAME, Fs, x, USE_BITS_INPUT, pioffset)

if ~exist('x','var')
  x = false;
else
  assert(Fs < 0);
end

if ~exist('USE_BITS_INPUT','var')
  USE_BITS_INPUT = false;
end

if ~exist('pioffset','var')
  pioffset = 0;
end


MOD_NAME = get_modname_alias(MOD_NAME);

M = get_modulation_order(MOD_NAME);

if USE_BITS_INPUT
  assert(false);
  k = log2(M);  % Number of bits per symbol
  if not(x)
    x = randi([0 1],Fs*k,1);
  end
else
  if not(x)
    x = randi([0 M-1],Fs,1);
  end
end

if contains(char(MOD_NAME),{'BPSK','QPSK','8PSK','16PSK','32PSK'})

  y = pskmod(x, M, pioffset, 'gray');

elseif contains(char(MOD_NAME),{'QAM8','QAM16','QAM32','QAM64','QAM128','QAM256'})

  y = qammod(x, M, 'gray','UnitAveragePower',true);
  y = y .* exp(1i*pioffset);

elseif contains(char(MOD_NAME),{'PAM4'})

  y = pammod(x, M, pioffset, 'gray');

elseif contains(char(MOD_NAME),{'GFSK'})

  mod = comm.CPMModulator('ModulationOrder', M, 'FrequencyPulse','Gaussian','ModulationIndex',1);
  meanM = mean(0:M-1);
  y = mod(2*(x-meanM));
  y = y .* exp(1i*pioffset);

elseif contains(char(MOD_NAME),{'CPFSK'})

  mod = comm.CPFSKModulator('ModulationOrder', M, 'ModulationIndex',0.5);
  meanM = mean(0:M-1);
  y = mod(2*(x-meanM));
  y = y .* exp(1i*pioffset);

else
  assert (false, 'unsupported modulatation type');
end

end