function X = extract_order_statistic(sigmat, ostype)

if ~islogical(ostype)
  assert(size(ostype,1)==size(sigmat,1))
  assert(size(ostype,2)==1)
  extractAll = false;
else
  assert(ostype)
  extractAll = true;
end

numFs = size(sigmat(1,:),2);
if (extractAll); numFs=numFs*4; else; numFs=numFs*2; end

x = zeros(size(sigmat, 1),numFs);

for i = 1:1:size(sigmat, 1)
  IQdata = sigmat(i,:);
  IQdata = normalize_signals(IQdata);

  if ~extractAll
    if ostype(i,1)
      x(i,:) = [sort(angle(IQdata)), sort(abs(IQdata))];
    else
      x(i,:) = [sort(real(IQdata)), sort(imag(IQdata))];
    end
  else
    x(i,:) = [sort(angle(IQdata)), sort(abs(IQdata)), sort(real(IQdata)), sort(imag(IQdata))];
  end
end

X = zeros(size(x,1),size(x,2));
for i = 1:size(x,2)
  assert(isreal(x(:,i)))
  X(:,i) = x(:,i);
end