function vectornew = transform_vector(vector, method)

if strcmp(method, 'abs')
  vectornew = abs(vector.*2);

elseif strcmp(method, 'angle')
  vectornew = angle(vector);

elseif strcmp(method, 'abs_diff')
  assert(size(vector,2) > 1)
  vectornew = abs(vector.*2);
  vectornew = diff(vectornew,1,2);
  assert(size(vectornew,2) == size(vector,2)-1)

elseif strcmp(method, 'diff_abs')
  assert(size(vector,2) > 1)
  vectornew = diff(vector,1,2);
  vectornew = abs(vectornew.*2);
  assert(size(vectornew,2) == size(vector,2)-1)

elseif strcmp(method, 'angle_diff')
  assert(size(vector,2) > 1)
  vectornew = angle(vector);
  for i = [size(vectornew,2):-1:2]
    vectornew(:,i) = angdiff(vectornew(:,i-1), vectornew(:,i));
  end
  vectornew = vectornew(:,2:end);
  assert(size(vectornew,2) == size(vector,2)-1)

elseif strcmp(method, 'diff_angle')
  assert(size(vector,2) > 1)
  vectornew = diff(vector,1,2);
  vectornew = angle(vectornew);
  assert(size(vectornew,2) == size(vector,2)-1)

else
  assert (false, 'unsupported normalize method');
end


end